
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/time.h>


enum {
//	_xinfreq = 20_000_000,
	_xtlfreq = 20_000_000,
	_clkfreq = 80_000_000,

};



//===================================================================================

int  calld_test( int num ) __attribute__((cog))
{
//    __asm volatile {  // no optimising and enforces Fcache use
    __asm {
		call	#call0
		calld	pa, #call1
		call	#call0
		ret

call0
		add	num, #1
		ret

call1
		add	num, #1
		push	pa
		ret
    }  // Exiting of Fcache/Cogexec triggers an implicit RDFAST

    return num;
}



void  main( void )
{
    uint32_t  mode, divd, mult, divp, freq;

    _waitms( 200 );
    mode = _clockmode();
    printf( "\n  Default:  clkfreq = %d   clkmode = 0x%x\n", _clockfreq(), mode );
    divd = ((mode >> 18) & 0x3f) + 1;
    mult = ((mode >> 8) & 0x3ff) + 1;
    divp = ((mode >> 4) + 1) & 0xf;
    divp = divp ? divp * 2 : 1;
    printf( " DIVD %d   MULT %d   DIVP %d\n", divd, mult, divp );

    printf( " Num = %d\n", calld_test( 5 ) );
    while(1)
        _waitms(500);
}
